//---------------------------------------------------------------------------
#ifndef PixGlobalsH
#define PixGlobalsH
// version 0.6
// types
enum TspeRenderType {px_rndDraw = 0};
enum TspeShapeType {px_shpFreeHand = 0, px_shpLine, px_shpEllipse, px_shpEllipseFilled, px_shpEllipseFilledNB,
					px_shpRectangle, px_shpRectangleFilled, px_shpRectangleFilledNB,
					px_shpPolyline, px_shpPolygon, px_shpPolygonFilled, px_shpPolygonFilledNB, px_shpSplieCR};
enum TspeBrushType {px_brshNeon = 0, px_brshSolid, px_brshSpray, px_brshStar, px_brshHair,
					px_brshMesh, px_brshParallel, px_brshStamp, px_brshCml};
enum TspeCloneType {px_cltExternal = 0, px_cltDirect, px_cltBuffered};          
// stroke events
const BYTE sp_SE_DOWN  = 0x01;
const BYTE sp_SE_MOVE  = 0x02;
const BYTE sp_SE_UP    = 0x04;
const BYTE sp_SE_PICK_COLOR = 0x08;
const BYTE sp_SE_RESET_CC = 0x10;
const BYTE sp_SE_FLUSH	= 0x20;
// color space scaling
const int px_SP_NORM           = 4194304;     // 2 ^ 22
const int px_SP_SHIFT          = 22;
// default scanline alignement
const int px_SP_ALIGNMENT      = 4;
// luminance
const float px_F_LUMINANCE[3] = {0.11, 0.59, 0.30};
const double px_D_LUMINANCE[3] = {0.11, 0.59, 0.30};
// color types
const int  px_CTYPE_PRIMARY          = 0;
const int  px_CTYPE_SECONDARY        = 1;
const int  px_CTYPE_MIXED            = 2;
const int  px_CTYPE_SOLIDMIXED       = 3;
const int  px_CTYPE_PALETTE          = 4;
const int  px_CTYPE_SOLIDPALETTE     = 5;
const int  px_CTYPE_TEXTUREALIGNED   = 6;
const int  px_CTYPE_TEXTUREFIXED     = 7;
const int  px_CTYPE_CLONEALIGNED     = 8;
const int  px_CTYPE_CLONEREPOS       = 9;
const int  px_CTYPE_CLONEFIXED       = 10;
const int  px_CTYPE_PALETTE_STEP_C   = 11;
const int  px_CTYPE_PALETTE_STEP_FB  = 12;
const int  px_CTYPE_PALETTE_STEP_STOP  = 13;
const int  px_CTYPE_MOUSE_DOWN       = 14;
const int  px_CTYPE_IMAGE_STEP       = 15;
const int  px_CTYPE_ABSQUE           = 16;
const int  px_CTYPE_SIDEKICK			= 17;
const int  px_CTYPE_GRADIENT_STEP_C    = 18;
const int  px_CTYPE_GRADIENT_STEP_FB   = 19;
const int  px_CTYPE_GRADIENT_STEP_STOP = 20;

// pixel aritmetika
const int  px_ARITH_NORM     = 0;
const int  px_ARITH_SCALED   = 1;
const int  px_ARITH_ERASE    = 2;
const int  px_ARITH_XOR      = 3;
const int  px_ARITH_AND      = 4;
const int  px_ARITH_OR       = 5;
const int  px_ARITH_ADD      = 6;
const int  px_ARITH_SUB      = 7;
const int  px_ARITH_MULT     = 8;
const int  px_ARITH_MULT_nA  = 9;
const int  px_ARITH_MULT_nB  = 10;
const int  px_ARITH_HIGHER   = 11;
const int  px_ARITH_LOWER    = 12;
const int  px_ARITH_MEAN     = 13;
const int  px_ARITH_MINMAX   = 14;
const int  px_ARITH_RANDOM   = 15;
const int  px_ARITH_EQUALIZE = 16;
const int  px_ARITH_BURNER   = 17;
const int  px_ARITH_INTENSITY_B = 18;
const int  px_ARITH_INTENSITY_A = 19;
const int  px_ARITH_A_MOD_B   = 20;
const int  px_ARITH_AxB      = 21;
const int  px_ARITH_BURN_LINEAR = 22;
const int  px_ARITH_SQRT_AB    = 23;
const int  px_ARITH_ABS_SUB     = 24;
const int  px_ARITH_EXCLUSION   = 25;
const int  px_ARITH_BUMP        = 26;
const int  px_ARITH_BUMP_COLOR  = 27;
//
const int  px_DRAW_ARITH[26]    =  {px_ARITH_NORM, px_ARITH_SCALED, px_ARITH_ERASE, px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR,
							   px_ARITH_ADD, px_ARITH_SUB, px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB,
							   px_ARITH_HIGHER, px_ARITH_LOWER, px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM,
							   px_ARITH_EQUALIZE, px_ARITH_BURNER, px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B,
							   px_ARITH_AxB, px_ARITH_BURN_LINEAR, px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION
							   };
const int  px_SHIFT_ARITH[25]   =  {px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR, px_ARITH_ADD, px_ARITH_SUB,
							   px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB, px_ARITH_HIGHER, px_ARITH_LOWER,
							   px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM, px_ARITH_EQUALIZE, px_ARITH_BURNER,
							   px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B, px_ARITH_AxB, px_ARITH_BURN_LINEAR,
							   px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION, px_ARITH_BUMP, px_ARITH_BUMP_COLOR
							   };
const int  px_SPREAD_ARITH[24]   =  {px_ARITH_NORM, px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR,
							   px_ARITH_ADD, px_ARITH_SUB, px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB,
							   px_ARITH_HIGHER, px_ARITH_LOWER, px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM,
							   px_ARITH_EQUALIZE, px_ARITH_BURNER, px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B,
							   px_ARITH_AxB, px_ARITH_BURN_LINEAR, px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION
							   };
const int  px_K33I[9]		     =  {-1, -1, -1, 0, 0, 0, 1, 1, 1};
const int  px_K33J[9]			 =  {-1, 0, 1, -1, 0, 1, -1, 0, 1};
// rendering modes
const int  px_RENDER_AUTOMATIC     = 0;
const int  px_RENDER_SLOW          = 1;
const int  px_RENDER_MEDIUM        = 2;
const int  px_RENDER_FAST          = 3;
const int  px_RENDER_DUMMY         = 4;
// 0.5 - scrath types
const int px_SCRATCH_NONE = 0;
const int px_SCRATCH_CIRCLE = 1;
const int px_SCRATCH_SQUARE = 1;
const int px_SCRATCH_SHORT_LINE = 2;
const int px_SCRATCH_LONG_LINE = 3;
#endif
