unit spGlobals;
{$IFNDEF PixGlobalsH}
{$DEFINE PixGlobalsH}
interface
uses
  Windows, Classes;

{=> version 0.6 <=}

type
   TspeRenderType =  (px_rndDraw = 0);
   TspeShapeType = (px_shpFreeHand = 0, px_shpLine, px_shpEllipse, px_shpEllipseFilled, px_shpEllipseFilledNB,
					px_shpRectangle, px_shpRectangleFilled, px_shpRectangleFilledNB,
					px_shpPolyline, px_shpPolygon, px_shpPolygonFilled, px_shpPolygonFilledNB, px_shpSplieCR);
   TspeBrushType = (px_brshNeon = 0, px_brshSolid, px_brshSpray, px_brshStar,
          px_brshHair, px_brshMesh, px_brshParallel, px_brshStamp, px_brshCml);
   TspeCloneType = (px_cltExternal = 0, px_cltDirect, px_cltBuffered);
const
    // stroke events
    sp_SE_DOWN: byte  = 1;
    sp_SE_MOVE: byte  = 2;
    sp_SE_UP: byte    = 4;
    sp_SE_PICK_COLOR: byte = 8;
    sp_SE_RESET_CC: byte = 16;
    sp_SE_FLUSH: byte	= 32;
    // color space scaling
    px_SP_NORM  = 4194304;     // 2 ^ 22
    px_SP_SHIFT = 22;
    // default alignement
    px_SP_ALIGNMENT  = 4;
    // luminance
    px_F_LUMINANCE: array[0..2] of Single = (0.11, 0.59, 0.30);
    px_D_LUMINANCE: array[0..2] of Double = (0.11, 0.59, 0.30);
    // color types
    px_CTYPE_PRIMARY: Integer           = 0;
    px_CTYPE_SECONDARY: Integer         = 1;
    px_CTYPE_MIXED: Integer            = 2;
    px_CTYPE_SOLIDMIXED: Integer       = 3;
    px_CTYPE_PALETTE          = 4;
    px_CTYPE_SOLIDPALETTE     = 5;
    px_CTYPE_TEXTUREALIGNED   = 6;
    px_CTYPE_TEXTUREFIXED     = 7;
    px_CTYPE_CLONEALIGNED     = 8;
    px_CTYPE_CLONEREPOS       = 9;
    px_CTYPE_CLONEFIXED       = 10;
    px_CTYPE_PALETTE_STEP_C   = 11;
    px_CTYPE_PALETTE_STEP_FB  = 12;
    px_CTYPE_PALETTE_STEP_STOP  = 13;
    px_CTYPE_MOUSE_DOWN       = 14;
    px_CTYPE_IMAGE_STEP       = 15;
    px_CTYPE_ABSQUE           = 16;
    px_CTYPE_SIDEKICK		      = 17;
    px_CTYPE_GRADIENT_STEP_C    = 18;
    px_CTYPE_GRADIENT_STEP_FB   = 19;
    px_CTYPE_GRADIENT_STEP_STOP = 20;
    // pixel arithmecics
    px_ARITH_NORM     = 0;
    px_ARITH_SCALED   = 1;
    px_ARITH_ERASE    = 2;
    px_ARITH_XOR      = 3;
    px_ARITH_AND      = 4;
    px_ARITH_OR       = 5;
    px_ARITH_ADD      = 6;
    px_ARITH_SUB      = 7;
    px_ARITH_MULT     = 8;
    px_ARITH_MULT_nA  = 9;
    px_ARITH_MULT_nB  = 10;
    px_ARITH_HIGHER   = 11;
    px_ARITH_LOWER    = 12;
    px_ARITH_MEAN     = 13;
    px_ARITH_MINMAX   = 14;
    px_ARITH_RANDOM   = 15;
    px_ARITH_EQUALIZE = 16;
    px_ARITH_BURNER   = 17;
    px_ARITH_INTENSITY_B = 18;
    px_ARITH_INTENSITY_A = 19;
    px_ARITH_A_MOD_B   = 20;
    px_ARITH_AxB      = 21;
    px_ARITH_BURN_LINEAR = 22;
    px_ARITH_SQRT_AB    = 23;
    px_ARITH_ABS_SUB     = 24;
    px_ARITH_EXCLUSION   = 25;
    px_ARITH_BUMP        = 26;
    px_ARITH_BUMP_COLOR  = 27;
    //
    px_DRAW_ARITH: array[0..25] of Integer =  (px_ARITH_NORM, px_ARITH_SCALED, px_ARITH_ERASE, px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR,
							   px_ARITH_ADD, px_ARITH_SUB, px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB,
							   px_ARITH_HIGHER, px_ARITH_LOWER, px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM,
							   px_ARITH_EQUALIZE, px_ARITH_BURNER, px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B,
							   px_ARITH_AxB, px_ARITH_BURN_LINEAR, px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION
							   );
    px_SHIFT_ARITH: array[0..24] of Integer   =  (px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR, px_ARITH_ADD, px_ARITH_SUB,
							   px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB, px_ARITH_HIGHER, px_ARITH_LOWER,
							   px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM, px_ARITH_EQUALIZE, px_ARITH_BURNER,
							   px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B, px_ARITH_AxB, px_ARITH_BURN_LINEAR,
							   px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION, px_ARITH_BUMP, px_ARITH_BUMP_COLOR
							   );
    px_SPREAD_ARITH: array[0..23] of Integer   =  (px_ARITH_NORM, px_ARITH_XOR, px_ARITH_AND, px_ARITH_OR,
							   px_ARITH_ADD, px_ARITH_SUB, px_ARITH_MULT, px_ARITH_MULT_nA, px_ARITH_MULT_nB,
							   px_ARITH_HIGHER, px_ARITH_LOWER, px_ARITH_MEAN, px_ARITH_MINMAX, px_ARITH_RANDOM,
							   px_ARITH_EQUALIZE, px_ARITH_BURNER, px_ARITH_INTENSITY_B, px_ARITH_INTENSITY_A, px_ARITH_A_MOD_B,
							   px_ARITH_AxB, px_ARITH_BURN_LINEAR, px_ARITH_SQRT_AB, px_ARITH_ABS_SUB, px_ARITH_EXCLUSION
							   );
    px_K33I: array[0..8] of Integer =  (-1, -1, -1, 0, 0, 0, 1, 1, 1);
    px_K33J: array[0..8] of Integer =  (-1, 0, 1, -1, 0, 1, -1, 0, 1);
    // rendering modes
    px_RENDER_AUTOMATIC     = 0;
    px_RENDER_SLOW          = 1;
    px_RENDER_MEDIUM        = 2;
    px_RENDER_FAST          = 3;
    px_RENDER_DUMMY         = 4;
    // 0.5 - scrath types
    px_SCRATCH_NONE = 0;
    px_SCRATCH_CIRCLE = 1;
    px_SCRATCH_SQUARE = 1;
    px_SCRATCH_SHORT_LINE = 2;
    px_SCRATCH_LONG_LINE = 3;
    

{$ENDIF}
implementation
end.
